﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;

namespace WPF_SummariesInGroupedRecord
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
            Loaded += new RoutedEventHandler(Window1_Loaded);
        }

        void Window1_Loaded(object sender, RoutedEventArgs e)
        {
            ObservableCollection<Data> datasource = new ObservableCollection<Data>()
            {
                new Data(){ SampleInfo="Record1", SampleValue1=10,SampleValue2=60},
                new Data(){ SampleInfo="Record2", SampleValue1=30,SampleValue2=90},
                new Data(){ SampleInfo="Record3", SampleValue1=10,SampleValue2=30},
                new Data(){ SampleInfo="Record4", SampleValue1=50,SampleValue2=50},
                new Data(){ SampleInfo="Record5", SampleValue1=10,SampleValue2=80},
                new Data(){ SampleInfo="Record6", SampleValue1=70,SampleValue2=20},
                new Data(){ SampleInfo="Record7", SampleValue1=50,SampleValue2=10},
                new Data(){ SampleInfo="Record8", SampleValue1=10,SampleValue2=10},
                new Data(){ SampleInfo="Record9", SampleValue1=80,SampleValue2=30}
            };
            xamDataGrid1.DataSource = datasource;

            xamDataGrid1.FieldSettings.AllowSummaries = true;
            this.xamDataGrid1.FieldSettings.SummaryDisplayArea = SummaryDisplayAreas.InGroupByRecords | SummaryDisplayAreas.TopLevelOnly;
            this.xamDataGrid1.FieldLayoutSettings.GroupBySummaryDisplayMode = GroupBySummaryDisplayMode.SummaryCellsAlwaysBelowDescription;
            this.xamDataGrid1.FieldLayoutSettings.HeaderPlacement = HeaderPlacement.OnTopOnly;
            
            FieldSortDescription deptSort = new FieldSortDescription();
            deptSort.Direction = System.ComponentModel.ListSortDirection.Descending;
            deptSort.FieldName = "SampleValue1";
            deptSort.IsGroupBy = true;
            this.xamDataGrid1.FieldLayouts[0].SortedFields.Clear();
            this.xamDataGrid1.FieldLayouts[0].SortedFields.Add(deptSort);

            SummaryDefinition sum = new SummaryDefinition();
            sum.Key = "Summary1";
            sum.Calculator = SummaryCalculator.Sum;
            sum.SourceFieldName = this.xamDataGrid1.FieldLayouts[0].Fields["SampleValue1"].Name;
            sum.StringFormat = "{2} = {0:N0}";
            this.xamDataGrid1.FieldLayouts[0].SummaryDefinitions.Add(sum);
        }
    }
}
